//=============================================================================
//  TListView ̍s̍ݒ
//  CN_MEASUREITEM gp@
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2022N1015 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows [Version 10.0.19043] + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls,
  Vcl.ExtCtrls;

type
  TListView = class(Vcl.ComCtrls.TListView)
  private
    FItemHeight : UInt;
    procedure SetItemHeight(const Value: UInt);
  protected
    procedure CNMeasureitem(var Message: TWMMeasureItem); message CN_MEASUREITEM;
  public
    property ItemHeight : UInt read FItemHeight write SetItemHeight;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    ListView1: TListView;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  Winapi.CommCtrl;

{$R *.dfm}

//=============================================================================
//  tH[̏
//
//  ŕ\Ă ItemHeight ̒l ListView.ItemHeight ̒lƓ
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LCol  : TListColumn;
  LItem : TListItem;
  LIndex: Integer;
begin
  ListView1.ViewStyle := vsReport;
  ListView1.OwnerDraw := True;
  ListView1.ItemHeight := 4;


  ListView1.Items.BeginUpdate;
  LCol := ListView1.Columns.Add;
  LCol.Caption := 'Test Items';
  LCol.Width   := 200;

  // eXg\p̃f[^
  for LIndex := 0 to 49 do begin
    LItem :=  ListView1.Items.Add;
    LItem.Caption := Format('    %.6d',[LIndex + 1]);
  end;
  ListView1.Items.EndUpdate;

  Button1Click(nil);
end;

//=============================================================================
//  ListView1 ̍s̍ύX
//
//  ŕ\Ă ItemHeight ̒l ListView.ItemHeight ̒lƓ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LRect : TRect;
begin
  if Sender <> nil then begin
    ListView1.ItemHeight := ListView1.ItemHeight + 2;
  end;

  // ListView  1 Ԗ ( CfbNX 0 ) ̍s̍擾ĕ\
  // uses  Winapi.CommCtrl Kv
  LRect := ListView1.Items[0].DisplayRect(drBounds);
  Panel1.Caption := 'ItemHeight : ' + IntToStr(LRect.Bottom - LRect.Top);
end;

{ TListView }

//-----------------------------------------------     -------------------------
//  TListView  CN_MEASUREITEM bZ[W
//  CN_MEASUREITEM ́CRg[ɎgɑMĂ郁bZ[W
//  ItemHeight ̒lݒ
//  OwnerDraw ̒l True łȂƋ@\Ȃ@
//-----------------------------------------------     -------------------------
procedure TListView.CNMeasureitem(var Message: TWMMeasureItem);
begin
  inherited;
  Message.MeasureItemStruct.itemHeight := FItemHeight;
end;

//-----------------------------------------------     -------------------------
//  ItemHeight vpeB̐ݒp\bh
//-----------------------------------------------     -------------------------
procedure TListView.SetItemHeight(const Value: UInt);
var
  LTopIndex : Integer;
begin
  if Value <> FItemHeight then begin
    FItemHeight := Value;

    if Items.Count > 1 then begin
      LTopIndex := TopItem.Index;
      Selected := nil;
      RecreateWnd;
      Scroll(0, LTopIndex * FItemHeight);
    end;
  end;
end;

end.
