//=============================================================================
//  TListView ̃Jwb_̍ݒ
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2022N1021 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows [Version 10.0.19043] + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls,
  Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

  function LVHeaderWndProc(hWnd: HWND; Msg: UINT; wParam: WPARAM;
    lParam: LPARAM): LRESULT; stdcall;
                                         var
  Form1: TForm1;

implementation

uses
  Winapi.CommCtrl,
  System.Types;

{$R *.dfm}

var
  FLVHOriginProc : Pointer;
  FhLVHeader     : THandle;

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LCol  : TListColumn;
  LItem : TListItem;
  LIndex: Integer;
begin
  ListView1.ViewStyle := vsReport;

  ListView1.Items.BeginUpdate;
  LCol := ListView1.Columns.Add;
  LCol.Caption := 'Test Items';
  LCol.Width   := 200;

  // eXg\p̃f[^
  for LIndex := 0 to 49 do begin
    LItem :=  ListView1.Items.Add;
    LItem.Caption := Format('    %.6d',[LIndex + 1]);
  end;
  ListView1.Items.EndUpdate;


  // Jwb_̃Rg[̃EBhEnh擾
  FhLVHeader := ListView_GetHeader(ListView1.Handle);
  // Jwb_Rg[ WndProc ޔCV WndProc ݒ
  FLVHOriginProc := Pointer(SetWindowLong(FhLVHeader,
                           GWL_WNDPROC,
                           NativeInt(@LVHeaderWndProc)));
end;

//=============================================================================
//  tH[鎞̏
//=============================================================================
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SetWindowLong(FhLVHeader, GWL_WNDPROC, NativeInt(FLVHOriginProc));
end;

//-----------------------------------------------------------------------------^
//  SetWindowLong ֐̃R[obN֐
//  TListView ̃Jwb_Rg[̃TuNX
//
//  HDM_LAYOUT bZ[Wߑď
//  PHDLayout \̂PHDLayout.WindowPos.cy wb_̍
//-----------------------------------------------------------------------------^
function LVHeaderwndProc(hWnd: HWND; Msg: UINT; wParam: WPARAM;
  lParam: LPARAM): LRESULT; stdcall;
var
  LHDLyaout : PHDLayout;
  LRect     : TRect;
begin
  Result := CallWindowProc(FLVHOriginProc, hWnd, Msg, wParam, lParam);

  if Msg = HDM_LAYOUT then begin
    LHDLyaout := PHDLayout(lParam);
    LHDLyaout.WindowPos.cy := 70;
    LHDLyaout.Rect.Top := LHDLyaout.WindowPos.cy + 2;

    // wb_̍擾ĕ\
@  Header_GetItemRect(FhLVHeader, 0, @LRect);
    Form1.Panel1.Caption := 'Header Height : ' + IntToStr(LRect.Bottom - LRect.Top);
  end;
end;

end.
